#ifndef SERVER_H

#include <rpc/rpc.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>
#include <math.h>

#include "inet.h"
#include "mapdefs.h"

#ifndef TRUE
#define TRUE 1
#define FALSE 0 
#endif

/************* External functions used in program *************/
extern int FingerHost(char *, int);
extern int Server(char *, char *, char *, char *);
extern int ReadBytes(int, char *, int);
extern int ReadInt (int, int *, int);
extern int WriteBytes(int, char *, int);

/************* Functions defined in program *************/
int SendMapBounds(int datasock);
int RecvInitCoords(int datasock, int *north, int *east);
int FindFile(int north, int east, int res, int *row_offset, 
             int *col_offset, char *f_name);
int SendUrlList(int ctrlsock);
int SendInitSegments(int datasock, int row_offset, int col_offset,
                     char *filename);
int RecvNewCoords(int datasock, int *north, int *south, int *east,
                  int *west, int *file_n, int *file_s, int *file_e,
                  int *file_w, char **filename);
int SendNewSegments(int datasock, int res, int *north, int *south,
                    int *east, int *west, int *file_n, int *file_s,
                    int *file_e, int *file_w, char **filename);

#define SERVER_H
#endif /* SERVER_H */
